<?php

/**
 * This file is part of the SIASAR package.
 *
 * PHP version 8.0
 *
 * SIASAR Global is a joint initiative launched by the governments of Honduras,
 * Nicaragua and Panama that soon expanded to other regions. The strategic
 * purpose of this initiative is to have a basic, updated and comparable
 * information tool on the rural water supply and sanitation services in place
 * in a given country.
 *
 * @category SIASAR_3
 *
 * @author   Pedro Pelaez <pedro@front.id>
 *
 * @license  https://www.gnu.org/licenses/gpl-3.0.html GPL v3
 *
 * @link     http://globalsiasar.org/es/contact
 */

namespace App\Forms\FieldTypes\Types;

use App\Forms\Annotation\FieldType;
use App\Forms\FieldTypes\AbstractBaseTargetFieldType;
use Symfony\Component\Uid\Ulid;

/**
 * ULID field type.
 *
 * @category SIASAR_3
 *
 * @author   Pedro Pelaez <pedro@front.id>
 *
 * @license  https://www.gnu.org/licenses/gpl-3.0.html GPL v3
 *
 * @link     http://globalsiasar.org/es/contact
 *
 * @FieldType(
 *     id = "ulid",
 *     label = "ULID field type. If required and empty generate a new ULID.",
 *     settings = {
 *         "required": "Is this field require?",
 *         "multivalued": "Is this field multivalued?",
 *         "weight": "Field weight",
 *         "meta": "Field metadata properties.",
 *         "sort": "Is this field sortable?",
 *         "filter": "Is this field filterable?",
 *     }
 * )
 */
class UlidFieldType extends AbstractBaseTargetFieldType
{

    /**
     * Field type properties.
     *
     * Used to define stored values in this field type how key value and default value how array value..
     *
     * @return array
     */
    public function getProperties(): array
    {
        return [
            'value' => '',
        ];
    }

    /**
     * @inheritDoc
     */
    public function isEmpty(): bool
    {
        if (!$this->record) {
            return true;
        }

        $value = $this->record->get($this->getId());

        if (!$value) {
            return true;
        }

        if ($this->isMultivalued()) {
            foreach ($value as $item) {
                if (!empty($item['value'])) {
                    return false;
                }
            }

            return true;
        }

        return empty($value);
    }

    /**
     * @inheritDoc
     */
    public function getDefaultValue(): array
    {
        return [
            'value' => '',
        ];
    }

    /**
     * Get a valid example raw data array.
     *
     * @param array $row
     *   Optional example row generated, to allow this field generates relative values.
     *
     * @return array
     */
    public function getExampleData(array $row = []): array
    {
        $ulid = new Ulid();

        return [
            'value' => $ulid->toBase32(),
        ];
    }

    /**
     * Get default field type settings.
     *
     * @return array
     */
    public function getDefaultSettings(): array
    {
        return array_merge(
            parent::getDefaultSettings(),
            [],
        );
    }

    /**
     * Get SQL table field definitions.
     *
     * @return string
     */
    public function getSqlFieldDefinitions(): string
    {
        return sprintf(
            '%s binary(16) %s COMMENT \'%s\'',
            $this->getId(),
            '',
            // ($this->isRequired() ? 'NOT NULL' : ''),
            '(DC2Type:ulid)'
        );
    }

    /**
     * Validate single field data.
     *
     * @param mixed $value Value in each property.
     * @param mixed $row   Complete row values..
     *
     * @return bool
     */
    public function isValidProperties(mixed &$value, mixed &$row): bool
    {
        // Field types default validations.
        if (!parent::isValidProperties($value, $row)) {
            return false;
        }
        // Empty not required value?
        if ($this->isRequired() && empty($value['value'])) {
            // Set a new autogenerated ULID.
            $value = $this->getExampleData();
        }
        // Validate ULID.
        try {
            if (empty($value['value'])) {
                $value['value'] = null;
            }
            $value['value'] = new Ulid($value['value']);
        } catch (\Exception $e) {
            $this->lastErrors[] = $this->t(
                '[@type] Field "@id" error: @msg',
                [
                    '@type' => $this->getFieldType(),
                    '@id' => $this->getId(),
                    '@msg' => $e->getMessage(),
                ]
            );

            return false;
        }

        // Data it's valid.
        return true;
    }

    /**
     * Prepare data to insert in form.
     *
     * @param array $data Data to insert in form. Data must be a single field data to insert.
     *
     * @return void
     */
    public function preInsert(&$data): void
    {
        if ($data instanceof Ulid) {
            $data = $data->toBinary();
        } elseif (isset($data['value']) && $data['value'] instanceof Ulid) {
            $data = $data['value']->toBinary();
        } elseif (is_null($data) || empty($data['value'])) {
            $data = null;
        } elseif (isset($data['value']) && is_string($data['value'])) {
            $ulid = new Ulid($data['value']);
            $data = $ulid->toBinary();
        }

        if ($this->isRequired() && is_null($data)) {
            // Auto generate.
            $ulid = new Ulid();
            $data = $ulid->toBinary();
        }
    }

    /**
     * @inheritDoc
     */
    public function formatToDatabase(string $property, mixed $value, array $item): mixed
    {
        if (empty($value)) {
            return '';
        }

        $ulid = Ulid::fromString($value);

        return $ulid->toBase32();
    }

    /**
     * @inheritDoc
     */
    public function formatToUse($value, bool $forceString = false): mixed
    {
        if (empty($value)) {
            return '';
        }

        $ulid = Ulid::fromString($value);

        return $ulid->toBase32();
    }

    /**
     * Field target.
     *
     * @param array|null $value Complete record value.
     *
     * @return mixed
     */
    public function getTarget(array|null $value): mixed
    {
        if (!$value) {
            return null;
        }

        if (empty($value['value'])) {
            return '';
        }

        $ulid = Ulid::fromString($value['value']);

        return $ulid->toBase32();
    }

    /**
     * Field source.
     *
     * This method allow to this field get extra information from the source instance.
     *
     * @param mixed $value Field data source, ex. a user instance.
     *
     * @return mixed
     */
    public function setSource(mixed $value): mixed
    {
        if ($value instanceof Ulid) {
            $value = $value->toBase32();
        } elseif (isset($value["value"]) && $value["value"] instanceof Ulid) {
            // Do nothing.
        } elseif (empty($value["value"])) {
            $value['value'] = '';
        } elseif (is_string($value)) {
            $ulid = new Ulid($value);
            $value = ['value' => $ulid->toBase32()];
        }

        return $value;
    }

    /**
     * @inheritDoc
     */
    public function isValidConditionalType(mixed $value): bool
    {
        return 'string' === gettype($value);
    }
}
